// intentaremos resolver https://omegaup.com/arena/problem/lsp/#problems
#include <stdio.h>
#include <limits.h>

struct coordenada {
   int fila;
   int columna;
};

struct coordenada_cuenta {
   int fila;
   int columna;
   int enfrentados;
};

int main( ) {
   int lobos, n;
   scanf("%d%d", &lobos, &n);

   char tablero[n][n + 1];
   for (int i = 0; i < n; ++i) {
      scanf("%s", &tablero[i][0]);
   }

   coordenada e, s;
   for (int i = 0; i < n; ++i) {
      for (int j = 0; j < n; ++j) {
         if (tablero[i][j] == 'E') {
            e = { i, j };
         } else if (tablero[i][j] == 'S') {
            s = { i, j };
         }
      }
   }

   int enfrentados[n][n];
   for (int i = 0; i < n; ++i) {
      for (int j = 0; j < n; ++j) {
         enfrentados[i][j] = INT_MAX;
      }
   }
   coordenada_cuenta cola[n * n * n * n];
   coordenada_cuenta *ini = cola, *fin = cola;
   enfrentados[e.fila][e.columna] = 0, *fin++ = { e.fila, e.columna, 0 };

   for (int d = 0; ini != fin; ++d) {
      for (coordenada_cuenta *f = fin; ini != f; ++ini) {
         coordenada_cuenta actual = *ini;
         if (actual.fila == s.fila && actual.columna == s.columna) {
            printf("%d\n", d);
            return 0;
         }

         coordenada vecinos[] = {
            { actual.fila - 1, actual.columna },
            { actual.fila + 1, actual.columna },
            { actual.fila, actual.columna - 1 },
            { actual.fila, actual.columna + 1 }
         };
         for (int i = 0; i < 4; ++i) {
            coordenada vecino = vecinos[i];
            if (0 <= vecino.fila && vecino.fila < n && 0 <= vecino.columna && vecino.columna < n && tablero[vecino.fila][vecino.columna] != '#') {
               int checar = actual.enfrentados + (tablero[vecino.fila][vecino.columna] == '*');
               if (checar <= lobos && checar < enfrentados[vecino.fila][vecino.columna]) {
                  enfrentados[vecino.fila][vecino.columna] = checar, *fin++ = { vecino.fila, vecino.columna, checar };
               }
            }
         }
      }
   }

   printf("-1\n");
}
