// resolver https://omegaup.com/arena/problem/lsp/#problems
#include <algorithm>
#include <stdio.h>
#include <limits.h>
using namespace std;

struct coordenada {
   int fila;
   int columna;
};

struct coordenada_cuenta {
   int fila;
   int columna;
   int enfrentados;
};

int main( ) {
   int lobos, n;
   scanf("%d%d", &lobos, &n);

   char tablero[n][n + 1];
   for (int i = 0; i < n; ++i) {
      scanf("%s", &tablero[i][0]);
   }

   coordenada e, s;
   for (int i = 0; i < n; ++i) {
      for (int j = 0; j < n; ++j) {
         if (tablero[i][j] == 'E') {
            e = { i, j };
         } else if (tablero[i][j] == 'S') {
            s = { i, j };
         }
      }
   }

   int enfrentados[n][n];
   for (int i = 0; i < n; ++i) {
      for (int j = 0; j < n; ++j) {
         enfrentados[i][j] = INT_MAX;
      }
   }
   int tam_actual = 0, tam_siguiente = 0;
   coordenada_cuenta mem[2][n * n];
   coordenada_cuenta *cola_actual = mem[0], *cola_siguiente = mem[1];
   enfrentados[e.fila][e.columna] = 0, cola_actual[tam_actual++] = { e.fila, e.columna, 0 };

   for (int d = 0; tam_actual != 0; ++d, swap(cola_actual, cola_siguiente), tam_actual = tam_siguiente, tam_siguiente = 0) {
      for (int i = 0; i < tam_actual; ++i) {
         coordenada_cuenta actual = cola_actual[i];
         if (actual.fila == s.fila && actual.columna == s.columna) {
            printf("%d\n", d);
            return 0;
         }

         coordenada vecinos[] = {
            { actual.fila - 1, actual.columna },
            { actual.fila + 1, actual.columna },
            { actual.fila, actual.columna - 1 },
            { actual.fila, actual.columna + 1 }
         };
         for (int i = 0; i < 4; ++i) {
            coordenada vecino = vecinos[i];
            if (0 <= vecino.fila && vecino.fila < n && 0 <= vecino.columna && vecino.columna < n && tablero[vecino.fila][vecino.columna] != '#') {
               int checar = actual.enfrentados + (tablero[vecino.fila][vecino.columna] == '*');
               if (checar <= lobos && checar < enfrentados[vecino.fila][vecino.columna]) {
                  enfrentados[vecino.fila][vecino.columna] = checar, cola_siguiente[tam_siguiente++] = { vecino.fila, vecino.columna, checar };
               }
            }
         }
      }
   }

   printf("-1\n");
}
